import { ISchemaDefinition } from "#sch";
import { ITskParkingZoneTariff } from "#sch/datasources/interfaces/ITskParkingZoneTariff";

export const TskParkingZoneTariffSchema: ISchemaDefinition<ITskParkingZoneTariff[]> = {
    name: "TskParkingZonesTariffSchema",
    jsonSchema: {
        type: "array",
        items: {
            type: "object",
            properties: {
                code: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                name: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                note: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                maxHour: { oneOf: [{ type: "number" }, { type: "null", nullable: true }] },
                maxPrice: { type: "number" },
                maxPriceHoliday: { oneOf: [{ type: "number" }, { type: "null", nullable: true }] },
                minPrice: { type: "number" },
                validFrom: { type: "string" },
                validTo: { type: "string" },
                divisibility: { oneOf: [{ type: "number" }, { type: "null", nullable: true }] },
                idOwner: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                idParkingArea: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                idTariffInt: { oneOf: [{ type: "number" }, { type: "null", nullable: true }] },
                idTariffDoprava: { oneOf: [{ type: "number" }, { type: "null", nullable: true }] },
                idTariffPM: { oneOf: [{ type: "number" }, { type: "null", nullable: true }] },
                idParkingAreaPrice: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                tariffGroups: {
                    type: "array",
                    items: {
                        type: "object",
                        properties: {
                            idTariff: { type: "string" },
                            groupNumber: { oneOf: [{ type: "number" }, { type: "null", nullable: true }] },
                            monday: { type: "boolean" },
                            tuesday: { type: "boolean" },
                            wednesday: { type: "boolean" },
                            thursday: { type: "boolean" },
                            friday: { type: "boolean" },
                            saturday: { type: "boolean" },
                            sunday: { type: "boolean" },
                            holiday: { oneOf: [{ type: "boolean" }, { type: "null", nullable: true }] },
                            maxPrice: { oneOf: [{ type: "number" }, { type: "null", nullable: true }] },
                            tariffDefinitions: {
                                type: "array",
                                items: {
                                    type: "object",
                                    properties: {
                                        idTariffGroup: { type: "string" },
                                        pricePerHour: { type: "number" },
                                        priceFlat: { oneOf: [{ type: "number" }, { type: "null", nullable: true }] },
                                        maxPriceItem: { oneOf: [{ type: "number" }, { type: "null", nullable: true }] },
                                        minPriceItem: { oneOf: [{ type: "number" }, { type: "null", nullable: true }] },
                                        timeFrom: { type: "string" },
                                        timeTo: { type: "string" },
                                        minuteFrom: { type: "number" },
                                        minuteTo: { type: "number" },
                                        onePerDay: { type: "boolean" },
                                        id: { type: "string" },
                                        activeFrom: { type: "string" },
                                        activeTo: { type: "string" },
                                        modifiedBy: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                                    },
                                    required: [
                                        "idTariffGroup",
                                        "timeFrom",
                                        "timeTo",
                                        "minuteFrom",
                                        "minuteTo",
                                        "onePerDay",
                                        "id",
                                        "activeFrom",
                                        "activeTo",
                                    ],
                                },
                            },
                            id: { type: "string" },
                            activeFrom: { type: "string" },
                            activeTo: { type: "string" },
                            modifiedBy: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                        },
                        required: [
                            "idTariff",
                            "monday",
                            "tuesday",
                            "wednesday",
                            "thursday",
                            "friday",
                            "saturday",
                            "sunday",
                            "id",
                            "activeFrom",
                            "activeTo",
                        ],
                    },
                },
                id: { type: "string" },
                activeFrom: { type: "string" },
                activeTo: { type: "string" },
                modifiedBy: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
            },
            required: ["maxPrice", "minPrice", "validFrom", "validTo", "id", "activeFrom", "activeTo"],
        },
    },
};
